"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _config = require("./config");

var Component = _config.config.Component;
var DEFAULT_LOCALE = 'en';

var LocalizedProvider =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(LocalizedProvider, _Component);

  function LocalizedProvider() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, LocalizedProvider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(LocalizedProvider)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      currentLocale: null,
      currentLocaleData: null
    });
    return _this;
  }

  (0, _createClass2.default)(LocalizedProvider, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this$state = this.state,
          currentLocale = _this$state.currentLocale,
          currentLocaleData = _this$state.currentLocaleData;
      return {
        i18n: {
          locale: currentLocale,
          localeData: currentLocaleData
        }
      };
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.updateLocaleData(this.props, this.state);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps, nextState) {
      var _this$props = this.props,
          locale = _this$props.locale,
          locales = _this$props.locales;
      var nextLocale = nextProps.locale,
          nextLocales = nextProps.locales;

      if (nextLocale !== locale || nextLocales !== locales) {
        this.updateLocaleData(nextProps, nextState);
      }
    }
  }, {
    key: "getLocaleFromProps",
    value: function getLocaleFromProps(props) {
      var locales = props.locales,
          locale = props.locale;
      return locales[locale] ? locale : DEFAULT_LOCALE;
    }
  }, {
    key: "updateLocaleData",
    value: function () {
      var _updateLocaleData = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(props, state) {
        var locales, locale, currentLocaleData;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                locales = props.locales;
                locale = this.getLocaleFromProps(props);

                if (!(locale !== state.currentLocale)) {
                  _context.next = 12;
                  break;
                }

                currentLocaleData = locales[locale];

                if (!(typeof currentLocaleData !== 'function')) {
                  _context.next = 8;
                  break;
                }

                this.setState({
                  currentLocale: locale,
                  currentLocaleData: currentLocaleData
                });
                _context.next = 12;
                break;

              case 8:
                _context.next = 10;
                return currentLocaleData();

              case 10:
                currentLocaleData = _context.sent;

                if (locale === this.getLocaleFromProps(this.props)) {
                  this.setState({
                    currentLocale: locale,
                    currentLocaleData: currentLocaleData
                  });
                }

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateLocaleData(_x, _x2) {
        return _updateLocaleData.apply(this, arguments);
      }

      return updateLocaleData;
    }()
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var currentLocale = this.state.currentLocale;
      var data = {
        locale: currentLocale
      };
      return (0, _isFunction.default)(children) ? children(data) : children[0](data);
    }
  }]);
  return LocalizedProvider;
}(Component);

exports.default = LocalizedProvider;
(0, _defineProperty2.default)(LocalizedProvider, "defaultProps", {
  locales: {},
  locale: DEFAULT_LOCALE,
  children: function children() {
    return null;
  }
});
(0, _defineProperty2.default)(LocalizedProvider, "childContextTypes", {
  i18n: function i18n() {}
});