"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _memoize = _interopRequireDefault(require("lodash/memoize"));

var _config = require("./config");

var Component = _config.config.Component,
    createElement = _config.config.createElement;
var memoizedPluralForm = (0, _memoize.default)(function (locale, localeData) {
  var messages = localeData.messages;

  if (messages) {
    // eslint-disable-next-line
    return Function('n', 'nplurals', 'plural', "".concat(messages[''].plural_forms, " return plural;"));
  }

  return function (n) {
    return n === 1 ? 0 : 1;
  };
});

var _default = function _default(WrappedComponent) {
  var _class, _temp;

  return _temp = _class =
  /*#__PURE__*/
  function (_Component) {
    (0, _inherits2.default)(LocalizedComponent, _Component);

    function LocalizedComponent() {
      var _getPrototypeOf2;

      var _this;

      (0, _classCallCheck2.default)(this, LocalizedComponent);

      for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
        _args[_key] = arguments[_key];
      }

      _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(LocalizedComponent)).call.apply(_getPrototypeOf2, [this].concat(_args)));
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "gettext", function () {
        var _this2;

        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return (_this2 = _this).pgettext.apply(_this2, [null].concat(args));
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "pgettext", function (context, input) {
        var message = _this.getMessage(input, context);

        var output;

        if (message) {
          output = (0, _isArray.default)(message) ? message[0] : message;
        } else {
          output = input;
        }

        for (var _len3 = arguments.length, injections = new Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
          injections[_key3 - 2] = arguments[_key3];
        }

        return _this.replaceInjections(output, injections);
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "ngettext", function () {
        var _this3;

        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        return (_this3 = _this).npgettext.apply(_this3, [null].concat(args));
      });
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "npgettext", function (context, singular, plural, n) {
        var message = _this.getMessage(singular, context);

        var output;

        if (message) {
          output = message[_this.getPluralForm(n)];
        } else {
          output = [singular, plural][_this.getPluralForm(n)];
        }

        for (var _len5 = arguments.length, injections = new Array(_len5 > 4 ? _len5 - 4 : 0), _key5 = 4; _key5 < _len5; _key5++) {
          injections[_key5 - 4] = arguments[_key5];
        }

        return _this.replaceInjections(output, injections);
      });
      return _this;
    }

    (0, _createClass2.default)(LocalizedComponent, [{
      key: "getPluralForm",
      value: function getPluralForm(n) {
        var locale = this.getLocale();
        var localeData = this.getLocaleData();
        return memoizedPluralForm(locale, localeData)(n);
      }
    }, {
      key: "getMessage",
      value: function getMessage(message, context) {
        var _this$getLocaleData = this.getLocaleData(),
            messages = _this$getLocaleData.messages;

        if (messages) {
          var messageId = context ? "".concat(context, "\x04").concat(message) : message;
          return messages[messageId] || null;
        }

        return null;
      }
    }, {
      key: "getLocale",
      value: function getLocale() {
        var locale = this.context.i18n.locale;
        return locale;
      }
    }, {
      key: "getLocaleData",
      value: function getLocaleData() {
        var localeData = this.context.i18n.localeData;
        return localeData || {};
      }
    }, {
      key: "replaceInjections",
      value: function replaceInjections(input, injections) {
        return input.replace(/{([0-9])}/g, function (match, index) {
          return injections[index];
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            localizedInnerRef = _this$props.localizedInnerRef,
            rest = (0, _objectWithoutProperties2.default)(_this$props, ["localizedInnerRef"]);
        var locale = this.getLocale();
        var localeData = this.getLocaleData();
        return createElement(WrappedComponent, (0, _objectSpread2.default)({}, rest, localeData.extra, {
          locale: locale,
          gettext: this.gettext,
          ngettext: this.ngettext,
          pgettext: this.pgettext,
          npgettext: this.npgettext,
          ref: localizedInnerRef
        }));
      }
    }]);
    return LocalizedComponent;
  }(Component), (0, _defineProperty2.default)(_class, "contextTypes", {
    i18n: function i18n() {}
  }), _temp;
};

exports.default = _default;